/**
Name:		ESP8266_NTPClass_TFT1.8.ino
Created:	16.02.2017 23:10:56
Author:		Yuri Gradov aka IOPA4
http://iopa4.narod.ru
ToDo:		
*/

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>
#include <ArduinoJson.h>
#include "NTP_Client.h" //применена слегка подправленная библиотека NTPClient, в ней нужно указать часовой пояс #define localZone х
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_ST7735.h>
#include "rgb565.h"
//#include "rusfont.h"



//extern const unsigned char rusfont[];
//подключение к индикатору TFT 1.8 v2
/*
 * GPIO5             Pin 06 (RESET)
 * GPIO2             Pin 07 (A0)
 * GPIO13 (HSPID)    Pin 08 (SDA)
 * GPIO14 (HSPICLK)  Pin 09 (SCK)
 * GPIO15 (HSPICS)   Pin 10 (CS)
  */

#define TFT_PIN_CS   15
#define TFT_PIN_DC   2
#define TFT_PIN_RST  5

#define DEBUG 0

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_PIN_CS, TFT_PIN_DC, TFT_PIN_RST);

const char* ssid      = "************"; //имя вашей WiFi сети
const char* password  = "********";     //и пароль доступа
const String server   = "http://api.openweathermap.org/"; //зарегистрироваться на этом сайте http://openweathermap.org/api
const String appid    = "********************************"; //и получить бесплатный ключ на получение погоды, до 60 запросов в минуту
//const String lat      = "69.07"; //ваша широта
//const String lon      = "33.42"; //ваша долгота
const String city     = "496278"; //код города взят с сайта https://openweathermap.org/widgets-constructor
const String cityname = "Severomorsk";
const String lng      = "ru";

//const String url     = server + "data/2.5/weather?id=" + city + "&units=metric&appid=" + appid; //запрос по номеру id города
//const String url     = server + "data/2.5/forecast?lat=" + lat + "&lon=" + lon + "&units=metric&appid=" + appid; //запрос по координатам*/
//const String url     = server + "data/2.5/forecast?lat=" + lat + "&lon=" + lon + "&units=metric&appid=" + appid; //запрос по координатам*/

#define forecast 1 //1 прогноз 0 настоящая

#if forecast
const String url     = server + "data/2.5/forecast/daily?q=" + cityname + "&units=metric&cnt=1&lang=" +lng + "&appid=" + appid; //запрос по имени города
#else
const String url     = server + "data/2.5/weather?id=" + city + "&units=metric&cnt=1&lang=" +lng + "&appid=" + appid; //запрос по номеру id города
#endif

bool first = 1, upd_data = 1;
char znak = '+';
String T = "", old_T = "", V = "", old_V = "", old_D = "", old_I= "", msg = "  ";
String H = "", M = "", S = "", D = "",I = "", C = "";
// вывод на экран сделан без полной очистки экрана (это исключает мерцание,
// старая надпись затирается черной заливкой и выводится новая
// все old_XXX переменные для сохранения старых значений для дальнейшего сравнения
// и если только новая величина не совпадает со старой, выводить на экран. Это значительно увеличивает скорость отрисовки.
unsigned char rumb;
char old_min = 0, old_hrs = 0;
const char* vind[16] = {"С","С-СВ","СВ","В-СВ",
                        "В","В-ЮВ","ЮВ","Ю-ЮВ",
                        "Ю","Ю-ЮЗ","ЮЗ","З-ЮЗ",
                        "З","З-СЗ","СЗ","С-СЗ"}; //названия румбов розы ветров

String httpData;

struct weather_structure {
  unsigned int id;
  const char* main;
  const char* icon;
  const char* descript;
  float temp;
  float pressure;
  byte  humidity;
  float speed;
  float deg;
};
weather_structure weather;

struct systime_structure {
  unsigned char sec;
  unsigned char min;
  unsigned char hrs;
};
systime_structure sys_time;

WiFiClient client;
CNTPTime ntpTime;

void Space(char x, char y, char w, char h) {
  tft.fillRect(x, y, w, h, ST7735_BLACK);
}

String IntToStr(int N)
{
  if (N<10) return "0" + String(N);
  else return String(N);
}

void PrintXY(char x, char y, String str) {
  tft.setCursor(x,y);
  tft.print(str);
}

/*
char StrLen(String ss)
{
  unsigned char i = 0, count =0;  
  while (ss[i] != '\0')
  {
    if (ss[i] > 'А') i=i+2;      // если кириллический символ, то проскакиваем следующий шаг
    else i++;
    count++;
  }
 #if DEBUG
  Serial.println(count);
  Serial.println(ss.length());
 #endif
  return count;
}
*/

void setup() {

#if DEBUG
  Serial.begin(115200);
  Serial.println();
	Serial.println();
	Serial.println();
#endif

  // инициализация дисплея
  tft.initR(INITR_BLACKTAB);
  tft.cp437(true);
//  tft.setFont(&rusfont);
  tft.setRotation(3);
  tft.fillScreen(ST7735_BLACK);
  PrintXY(0, 0,(utf8rus("Старт WiFi! \r\n")));

  WiFi.mode(WIFI_STA);
	WiFi.begin(ssid, password);
	delay(2000);
	while (WiFi.status() != WL_CONNECTED) {
		 delay(200);
	}
   tft.println(utf8rus("Cоединение"));
   tft.println(ssid);
	 tft.print(utf8rus("установлено!"));
   delay(2000);
	 ntpTime.Init();
   tft.fillScreen(ST7735_BLACK);
   if (first==1)
   {
     ntpTime.getTime(); 
     httpRequest();
     parseData();
     sys_time.sec = ntpTime.Second;
     sys_time.min = ntpTime.Minute;
     sys_time.hrs = ntpTime.Hour;
   };
}

void loop() {
	static int prevSec = 0;
  int x, l;
  if (millis()%1000 == 0) sys_time.sec++;
  if (sys_time.sec>=60)
  {
     sys_time.sec=0;
     sys_time.min++;
  }
  if (sys_time.min>=60)
  {
    sys_time.min=0;
    sys_time.hrs++;
  };
   //запрашиваем и синхронизируем время каждый час
  if (sys_time.hrs!=old_hrs) {
      sys_time.hrs = 0;
      ntpTime.getTime();
      sys_time.hrs = ntpTime.Hour; 
      sys_time.sec = ntpTime.Second;
      sys_time.min = ntpTime.Minute;
    };

	//обновляем дисплей каждую секунду
	if (prevSec != sys_time.sec) {
      H = IntToStr(sys_time.hrs);
      M = IntToStr(sys_time.min);
      S = IntToStr(sys_time.sec);    
     if (((V == "--")||(C=="--")) &&(old_min != sys_time.min)) //если состояние ветра и облачности принято не верно обновляем погоду каждую минуту
     {
       httpRequest();
       parseData();      
     }
     //запрашиваем погоду каждые 30 минут
     if ((sys_time.min%30 == 0) && (sys_time.sec == 0) || (first==1))
     {
       httpRequest();
       parseData();
       if (weather.temp < 0) znak = '-'; 
       else if (weather.temp > 0) znak = '+';
       else znak = ' ';
       rumb = round((weather.deg + 11.25)/22.5);
       if (rumb==16) rumb=0;
       msg = vind[rumb];
       V = msg+ " " + String(round(weather.speed)) + " м/с";
       T =  znak + String(round(weather.temp))+" "+ String(round(weather.humidity))+"% "+ String(round(weather.pressure * 0.75)) + "мм";
       D = IntToStr(ntpTime.Day) + "/" + IntToStr(ntpTime.Month) + "/" + IntToStr(ntpTime.Year);
       I = weather.icon;
       C = weather.descript;
     }
    
     //температура, влажность, давление
     l = T.length() - 2; //два русских знака - мм
     //x = 80 -  l*10/2;
     if (l>=15) x = 0; else x = 80 -  l*9/2;
     if (old_T!=T){
       tft.setTextSize(2);
       tft.setTextColor(ST7735_ORANGERED);
       Space(0, 0, 160, 14);
       PrintXY(0, 0, utf8rus(T));
       old_T = T;
     }

    //ветер
     l = V.length() - 2; //две русские буквы м и с 
     x = 80 -  l*10/2;
     if ((l<14)&&(l>7)) { //защита от мусора, если больше 14 знаков или меньше 7 ( слово Ю-ЮВ 11 м/с или C 1 m/s)
     if (old_V != V) {
       tft.setTextColor(ST7735_YELLOW);
       tft.setTextSize(2);
       Space(0, 20, 160, 14);
       old_V = V;
       PrintXY(x, 20, utf8rus(V));   
     }
   }  else 
   {
       V = "--";
       tft.setTextColor(ST7735_YELLOW);
       tft.setTextSize(2);
       Space(0, 20, 160, 14);
       old_V = V;
       PrintXY(x, 20, utf8rus(V));   
   }

    //облачность, иногда принимается мусор
    l = C.length()/2; //вся строка русскими буквами
    x = 80 -  l*5/2;
    if ((l<14)&&(l>4)) { //защита от мусора, если больше 14 знаков или меньше 4 (слово ясно)
      if (old_I!= I) {
        tft.setTextSize(1);
        tft.setTextColor(ST7735_WHITE); 
        Space(0, 41, 160, 7); //надежно стирает всю строку
        old_I = I; 
        C.toUpperCase();
        PrintXY(x, 41, utf8rus(C));   
      }
    }
    else 
    {
        C = "--";
        tft.setTextSize(1);
        tft.setTextColor(ST7735_WHITE); 
        Space(0, 41, 160, 7); //надежно стирает всю строку
        old_I = I; 
        PrintXY(x, 41, utf8rus(C));  
    }

//дата  
    if (old_D!=D) {
      tft.setTextSize(2);  
      tft.setTextColor(ST7735_CYAN); 
      Space(20, 60, 140, 14);
      old_D = D; 
      PrintXY(20, 60, D);     
    }


//час, минута, секунда    
    
    if (old_hrs!=sys_time.hrs) {
      tft.setTextSize(4);
      tft.setTextColor(ST7735_LIGHTGREEN);
      Space(20, 82, 45, 28);
      PrintXY(20, 82, H);
      old_hrs = sys_time.hrs;
    }

    
    if (old_min!=sys_time.min){
      tft.setTextSize(4);
      tft.setTextColor(ST7735_LIGHTGREEN);
      Space(94, 82, 45, 28);
      old_min = sys_time.min;
      PrintXY(94, 82, M);  
    }
    
    tft.setTextSize(2);
    tft.setTextColor(ST7735_LIGHTGREEN);
    Space(68, 90, 22, 14);
    PrintXY(68, 90, S);
    first = 0;
		prevSec = sys_time.sec;
  }
}

bool httpRequest() {
  HTTPClient wclient;
  bool find = false;
  client.setTimeout(1000);
#if DEBUG
  Serial.print("Connecting ");
#endif
  wclient.begin(url);
  int httpCode = wclient.GET();

  if (httpCode > 0) {
#if DEBUG
    Serial.printf("successfully, code: %d\n", httpCode);
#endif
    if (httpCode == HTTP_CODE_OK) {
      httpData = wclient.getString();
#if forecast
      if (httpData.indexOf(F("\"main\":{\"temp\":")) > -1) {
        find = true;
#else
      if (httpData.indexOf(F("\"main\":{\"temp\":")) > -1) {
        find = true;
#endif
      }
#if DEBUG
      else Serial.println("Failed, json string is not found");
#endif
    }
  }
#if DEBUG
   else Serial.printf("failed, error: %s\n", wclient.errorToString(httpCode).c_str());
#endif
  wclient.end();
  return find;
}

bool parseData() {
#if DEBUG
  Serial.println(httpData);
#endif

  DynamicJsonBuffer jsonBuffer;
  JsonObject& root = jsonBuffer.parseObject(httpData);

  if (!root.success()) {
#if DEBUG
    Serial.println("Json parsing failed!");
    return false;
#endif
  }

#if forecast
  weather.id       = root["list"][0]["weather"][0]["id"];
  weather.main     = root["list"][0]["weather"][0]["main"];
  weather.descript = root["list"][0]["weather"][0]["description"];
  weather.icon     = root["list"][0]["weather"][0]["icon"];
  weather.temp     = root["list"][0]["temp"]["day"];
  weather.humidity = root["list"][0]["humidity"];
  weather.pressure = root["list"][0]["pressure"];
  weather.speed    = root["list"][0]["speed"];
  weather.deg      = root["list"][0]["deg"];
#else
  weather.id       = root["weather"][0]["id"];
  weather.main     = root["weather"][0]["main"];
  weather.descript = root["weather"][0]["description"];
  weather.icon     = root["weather"][0]["icon"];
  weather.temp     = root["main"]["temp"];
  weather.humidity = root["main"]["humidity"];
  weather.pressure = root["main"]["pressure"];
  weather.speed    = root["wind"]["speed"];
  weather.deg      = root["wind"]["deg"];
 #endif

  httpData = "";
  return true;
}
