/*
#########################################################
#
#  RGB565:  LIST OF NAMED 16-BIT COLORS
#
#  Compiled by:  Bruce E. Hall <bhall66@gmail.com>
#         Date:  3 Mar 2014
#
#  Each color is represented by a 16-bit word
#  There are 5 red bits, 6 green bits, and 5 blue bits
#  in the format:  rrrrrggg.gggbbbbb
#
#########################################################
*/

#define ST7735_ALICEBLUE         0xF7DF
#define ST7735_ANTIQUEWHITE      OxFF5A
#define ST7735_AQUA              0x07FF
#define ST7735_AQUAMARINE        0x7FFA
#define ST7735_AZURE             0xF7FF
#define ST7735_BEIGE             0xF7BB
#define ST7735_BISQUE            0xFF38
#define ST7735_BLACK             0x0000
#define ST7735_BLANCHEDALMOND    0xFF59
#define ST7735_BLUE              0x001F
#define ST7735_BLUEVIOLET        0x895C
#define ST7735_BROWN             0xA145
#define ST7735_BURLYWOOD         0xDDD0
#define ST7735_CADETBLUE         0x5CF4
#define ST7735_CHARTREUSE        0x7FE0
#define ST7735_CHOCOLATE         0xD343
#define SST7735_CORAL             0xFBEA
#define ST7735_CORNFLOWERBLUE    0x684D
#define ST7735_CORNSILK          0xFFDB
#define ST7735_CRIMSON           0xD8A7
#define ST7735_CYAN              0x07FF
#define ST7735_DARKBLUE          0x0011
#define ST7735_DARKCYAN          0x0451
#define ST7735_DARKGOLDENROD     0xBC21
#define ST7735_DARKGRAY          0xAD55
#define ST7735_DARKGREEN         0x0320
#define ST7735_DARKKHAKI         0xBDAD
#define ST7735_DARKMAGENTA       0x8811
#define ST7735_DARKOLIVEGREEN    0x5345
#define ST7735_DARKORANGE        0xFC60
#define ST7735_DARKORCHID        0x9999
#define ST7735_DARKRED           0x8800
#define ST7735_DARKSALMON        0xECAF
#define ST7735_DARKSEAGREEN      0x8DF1
#define ST7735_DARKSLATEBLUE     0x49F1
#define ST7735_DARKSLATEGRAY     0x2A69
#define ST7735_DARKTURQUOISE     0x067A
#define ST7735_DARKVIOLET        0x901A
#define ST7735_DEEPPINK          0xF8B2
#define ST7735_DEEPSKYBLUE       0x05FF
#define ST7735_DIMGRAY           0x6B4D
#define ST7735_DODGERBLUE        0x1C9F
#define ST7735_FIREBRICK         0xB104
#define ST7735_FLORALWHITE       0xFFDE
#define ST7735_FORESTGREEN       0x2444
#define ST7735_FUSCHIA           0xF81F
#define ST7735_GAINSBORO         0xDEFB
#define ST7735_GHOSTWHITE        0xFFDF
#define ST7735_GOLD              0xFEA0
#define ST7735_GOLDENROD         0XDD24
#define ST7735_GRAY              0x8410
#define ST7735_GREEN             0x0400
#define ST7735_GREENYELLOW       0xAFE5
#define ST7735_HONEYDEW          0xF7FE
#define ST7735_HOTPINK           0xFB56
#define ST7735_INDIANRED         0xCAEB
#define ST7735_INDIGO            0x4810
#define ST7735_IVORY             0xFFFE
#define ST7735_KHAKI             0xF731
#define ST7735_LAVENDER          0xE73F
#define ST7735_LAVENDERBLUSH     0xFF9E
#define ST7735_LAWNGREEN         0x7FE0
#define ST7735_LEMONCHIFFON      0xFFD9
#define ST7735_LIGHTBLUE         0xAEDC
#define ST7735_LIGHTCORAL        0xF410
#define ST7735_LIGHTCYAN         0xE7FF
#define ST7735_LIGHTGOLD         0xFFDA
#define ST7735_LIGHTGREEN        0x9772
#define ST7735_LIGHTGRAY         0xD69A
#define ST7735_LIGHTPINK         0xFDB8
#define ST7735_LIGHTSALMON       0xFD07
#define ST7735_LIGHTSEAGREEN     0x2595
#define ST7735_LIGHTSKYBLUE      0x867F
#define ST7735_LIGHTSLATEGRAY    0x7453
#define ST7735_LIGHTSTEELBLUE    0xB63B
#define ST7735_LIGHTYELLOW       0xFFFC
#define ST7735_LIME              0x07E0
#define ST7735_LIMEGREEN         0x3666
#define ST7735_LINEN             0xFF9C
#define ST7735_MAGENTA           0xF81F
#define ST7735_MAROON            0x8000
#define ST7735_MEDAQUAMARINE     0x6675
#define ST7735_MEDIUMBLUE        0x0019
#define ST7735_MEDIUMORCHID      0xBABA
#define ST7735_MEDIUMPURPLE      0x939B
#define ST7735_MEDIUMSEAGREEN    0x3D8E
#define ST7735_MEDIUMSLATEBLUE   0x7B5D
#define ST7735_MEDSPRINGGREEN    0x07D3
#define ST7735_MEDIUMTURQUOISE   0x4E99
#define ST7735_MEDIUMVIOLETRED   0xC0B0
#define ST7735_MIDNIGHTBLUE      0x18CE
#define ST7735_MINTCREAM         0xF7FF
#define ST7735_MISTYROSE         0xFF3C
#define ST7735_MOCCASIN          0xFF36
#define ST7735_NAVAJOWHITE       0xFEF5
#define ST7735_NAVY              0x0010
#define ST7735_OLDLACE           0xFFBC
#define ST7735_OLIVE             0x8400
#define ST7735_OLIVEDRAB         0x6C64
#define ST7735_ORANGE            0xFD20
#define ST7735_ORANGERED         0xFA20
#define ST7735_ORCHID            0xDB9A
#define ST7735_PALEGOLDENROD     0xEF55
#define ST7735_PALEGREEN         0x9FD3
#define ST7735_PALETURQUOISE     0xAF7D
#define ST7735_PALEVIOLETRED     0xDB92
#define ST7735_PAPAYAWHIP        0xFF7A
#define ST7735_PEACHPUFF         0xFED7
#define ST7735_PERU              0xCC27
#define ST7735_PINK              0xFE19
#define ST7735_PLUM              0xDD1B
#define ST7735_POWDERBLUE        0xB71C
#define ST7735_PURPLE            0x8010
#define ST7735_RED               0xF800
#define ST7735_ROSYBROWN         0xBC71
#define ST7735_ROYALBLUE         0x435C
#define ST7735_SADDLEBROWN       0x8A22
#define ST7735_SALMON            0xFC0E
#define ST7735_SANDYBROWN        0xF52C
#define ST7735_SEAGREEN          0x2C4A
#define ST7735_SEASHELL          0xFFBD
#define ST7735_SIENNA            0xA285
#define ST7735_SILVER            0xC618
#define ST7735_SKYBLUE           0x867D
#define ST7735_SLATEBLUE         0x6AD9
#define ST7735_SLATEGRAY         0x7412
#define ST7735_SNOW              0xFFDF
#define ST7735_SPRINGGREEN       0x07EF
#define ST7735_STEELBLUE         0x4416
#define ST7735_TAN               0xD5B1
#define ST7735_TEAL              0x0410
#define ST7735_THISTLE           0xDDFB
#define ST7735_TOMATO            0xFB08
#define ST7735_TURQUOISE         0x471A
#define ST7735_VIOLET            0xEC1D
#define ST7735_WHEAT             0xF6F6
#define ST7735_WHITE             0xFFFF
#define ST7735_WHITESMOKE        0xF7BE
#define ST7735_YELLOW            0xFFE0
#define ST7735_YELLOWGREEN       0x9E66
